package wifky_autolink;

$main::preferences{AutoLink} = [
    {
        desc =>"Prefix for title of autolinked page" , 
        name =>"autolink_prefix" 
    },
    { 
        desc =>"Postfix for title of autolinked page",
        name =>"autolink_postfix" 
    },
];

my $prefix =$main::config{autolink_prefix};
my $postfix=$main::config{autolink_postfix};

if( $postfix || $prefix ){
    my $startsWith=unpack('h*',$prefix || '');
    my $endsWith  =unpack('h*',$postfix || '');
    @wifky_autolink::symbols = sort{ length($b) <=> length($a) }
        grep( defined($_)
        ,map( ($_=~/^${startsWith}(.+)${endsWith}$/ 
              ? pack('h*',$1)
              : undef ) , &main::list_page() ));

    ### for 1.1
    (*main::default_syntax_engine , *wifky_autolink::org_engine)
	= (*wifky_autolink::pre_syntax_engine , *main::default_syntax_engine);

    ### for 1.0
    $main::syntax_engine = \&wifky_autolink::pre_syntax_engine;
}

sub pre_syntax_engine{
    my ($text,$session) = @_;
    ### Seal innerlink-1 and attachment
    $$text =~ s/(&[lg]t;){2}\{.+?\}/"\f".unpack('h*',$&)."\f"/ge;

    ### Seal innerlink-2
    $$text =~ s/\[\[.+?\]\]/"\f".unpack('h*',$&)."\f"/ge;

    ### Seal outerlink-1 and rawurl
    $$text =~ s!($main::RXURL)(\{([^\}]+)\})?!
			    "\f".unpack('h*',$&)."\f"!ge;
    ### Seal outerlink-2
    $$text =~ s!\[([^\|]+)\|((?:\.\.?/|$main::PROTOCOL://)[^\]]+)\]!
			    "\f".unpack('h*',$&)."\f"!ge;
    ### Seal plugin
    $$text =~ s/\(\(.+?\)\)/"\f".unpack('h*',$&)."\f"/ge;

    foreach my $word ( @wifky_autolink::symbols ){
	$$text =~ s/\Q$word\E/
	    "\f".unpack('h*',"[[$&|$prefix$&$postfix]]")."\f"/ge;
    }
    $$text =~ s/\f((?:[0-9a-fA-F][0-9a-fA-F])+?)\f/pack('h*',$1)/ge;

    &wifky_autolink::org_engine($text,$session);
};
